
#include "missile.hxx"
#include "common.hxx"

// color the missile.
void missile::setColor(float red, float green, float blue)
{
	R = red;
	G = green;
	B = blue;
}

// draw an explosion.
void missile::drawExplosion()
{
	// draw concentric stipples at missile position
	// gives an animated effect.
	int rad = 0;
	glPushMatrix();
		glColor3f(0.0,1.0, 0);
		glTranslatef(this->MdeltaX, this->MdeltaY, 0);
		glScalef(3.0,3.0,0);
		glRotatef(this->Mangle,0.0,0.0,1.0);
		glLineStipple(1, 0x00FF);
		glBegin(GL_LINES);
			for (int i = 0;i < 3;i++)
			{
				rad+=4;				
				for (float theta = 0;theta < (2*PI);theta+= (PI/180))
					glVertex2f(rad *cosf(theta), rad *sinf(theta));
			}	
		glEnd();
	glPopMatrix();
}	

// draw the missile.
void missile::drawMissile()	
{
	// do the transformations
	glPushMatrix();
		glColor3f(R,G,B);
		glTranslatef(this->MdeltaX, this->MdeltaY, 0);
		glRotatef(this->Mangle,0.0,0.0,1.0);
		glBegin(GL_LINE_LOOP);
			glVertex2f(1.0,1.0);	// missile is 2 units wide 
			glVertex2f(-1.0,1.0);	// and 2 units tall
			glVertex2f(-1.0,-1.0);
			glVertex2f(1.0,-1.0);
		glEnd();
		glPopMatrix();
}	

// returns the centre of the missile in x direction.
float missile::getMdeltaX()
{
	return MdeltaX;
}	

// returns the centre of the missile in x direction.
float missile::getMdeltaY()
{
	return MdeltaY;
}	

// initializes the centre of the missile.
void missile::setMValues(float X, float Y,float a)
{
	MdeltaX = X;
	MdeltaY = Y;
	Mangle = a;
}

// update the speed of the missile.
void missile::changeMValues(float speed)
{
	MdeltaX = MdeltaX + (speed * sinf(Mangle*PI/180)); // x component
	MdeltaY = MdeltaY + (speed * cosf(Mangle*PI/180)); // y component
	
}

// returns the status of missileFired.
int missile::isMissileFired()
{
	return missileFired;
}

// sets the missileFired flag.
void missile::setMissileFired()
{
	missileFired = TRUE;
}

// resets the missileFired flag.
void missile::resetMissileFired()
{
	missileFired = FALSE;
}
